import java.io.*;
import java.util.StringTokenizer;

public class CopyLines {

    public static void main(String args[]) {

        if(args.length < 2) {
            System.err.println("Sintaxe: java CopyLines mcs.data irc.data");
        } else {
            try {
                BufferedReader mcsFile = new BufferedReader(new FileReader(args[0]));
                BufferedReader ircFile = new BufferedReader(new FileReader(args[1]));

                while(true) {
                    String mcsLine = mcsFile.readLine();
                    String ircLine = ircFile.readLine();
                    if(mcsLine == null)
                        break;
                    StringTokenizer st = new StringTokenizer(mcsLine);

                    // Reads the method's name
                    String mName  = st.nextToken();
                    String isChordal = st.nextToken();
                    if(isChordal.equals("true"))
                        System.out.println(ircLine);
                }

            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
