package fernandoVisitorSet;

import FernandoGraph.*;

import joeq.Compiler.Quad.*;
import joeq.Compiler.Quad.SSA.*;
import joeq.Compiler.Dataflow.*;
import joeq.Main.Helper;
import joeq.Class.*;
import joeq.Util.Templates.*;

import java.io.IOException;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.HashSet;

public class RegAllocVisitor implements jq_MethodVisitor {

    private int numRegisters = 0;

    private boolean isMCS = false;

    private boolean isSSA = false;

    private String className = null;

    private boolean toGraph = false;

    public void visitClassInitializer(jq_ClassInitializer m) {}

    public void visitInitializer(jq_Initializer m) {}

    public void visitInstanceMethod(jq_InstanceMethod m) {}

    public void visitStaticMethod(jq_StaticMethod m) {}

    public void setClassName(String className) {
        this.className = className;
    }

    public RegAllocVisitor(boolean isSSA, boolean isMCS, int numRegisters, boolean toGraph) {
        this.numRegisters = numRegisters;
        this.isMCS = isMCS;
        this.isSSA = isSSA;
        this.toGraph = toGraph;
    }

    public void visitMethod(jq_Method m) {
        InterferenceGraphBuilder igb = new InterferenceGraphBuilder(this.isSSA, this.isMCS, this.numRegisters, this.toGraph, this.className);
        Helper.runPass(m, igb);
    }

}
