import java.io.*;
import java.util.StringTokenizer;

public class ReadTime {

    public static void main(String args[]) {

        if(args.length < 1) {
            System.err.println("Sintaxe: java ReadTime file.time");
        } else {
            try {
                BufferedReader mcsFile = new BufferedReader(new FileReader(args[0]));

                int spillTime = 0;
                int colorTime = 0;
                int coalsTime = 0;

                while(true) {
                    String mcsLine = mcsFile.readLine();
                    if(mcsLine == null)
                        break;
                    if(Character.isDigit(mcsLine.charAt(0))) {
                        StringTokenizer st = new StringTokenizer(mcsLine);

                        // Reads the method's name
                        spillTime += Integer.parseInt(st.nextToken());
                        colorTime += Integer.parseInt(st.nextToken());
                        coalsTime += Integer.parseInt(st.nextToken());
                    }
                }

                System.out.println("Spill time = " + spillTime);
                System.out.println("Coloring time = " + colorTime);
                System.out.println("Coalescing time = " + coalsTime);

            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
